<?php

namespace App\Controller;

use App\Entity\CommonList;
use App\Entity\Film;
use App\Form\FilmType;
use App\Repository\CommonListRepository;
use App\Repository\FilmRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Attribute\Route;

class IndexController extends AbstractController
{
    #[Route('/{id?}', name: 'app_index', methods: ['GET', 'POST'], requirements: ['id' => '\d+'])]
    public function index(Request $request, FilmRepository $filmRepository, CommonListRepository $commonListRepository, ?Film $film = null): Response
    {
        $film = $film ?? new Film();
        $form = $this->createForm(FilmType::class, $film);

        $commonList = $commonListRepository->findAll();

        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            if (null === $film->getId()) {
                $commonList = CommonList::new($film, $this->getUser());
            }

            $filmRepository->save($film, true);
            $commonListRepository->save($commonList, true);

            return $this->redirectToRoute('app_index', [], RedirectResponse::HTTP_SEE_OTHER);
        }

        return $this->render('index/index.html.twig', [
            'commonList' => $commonList,
            'form' => $form
        ]);
    }

    #[Route('/update-order', name: 'update_order', methods: ['POST'])]
    public function updateOrder(Request $request): Response
    {
        dump($request->get('oldIndex'));
        dump($request->get('newIndex'));


        return new Response('Order updated', Response::HTTP_OK);
    }
}
